﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace ElementBaeume
{
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            InitializeComponent();
            Debug.WriteLine("");
            GetLogicalTree(0, this);
        }

        protected override void OnContentRendered(EventArgs e)
        {
            base.OnContentRendered(e);
            Debug.WriteLine("");
            GetVisualTree(0, this);
        }

        void GetLogicalTree(int depth, object obj)
        {
            Debug.WriteLine(new string('-', depth) + obj);
            if (obj is DependencyObject == false) return;
            foreach (object child in LogicalTreeHelper.GetChildren(obj as DependencyObject))
                GetLogicalTree(depth + 4, child);
        }

        void GetVisualTree(int depth, DependencyObject obj)
        {
            Debug.WriteLine(new string('-', depth) + obj.ToString());
            for (int i = 0; i < VisualTreeHelper.GetChildrenCount(obj); i++)
                GetVisualTree(depth + 4, VisualTreeHelper.GetChild(obj, i));
        }
    }
}

