﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace ChangeNotificationSample
{
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        Person pers = new Person { Name = "Manfred Fischer", Alter = null, Adresse = "Köln, Bahnhofstraße" };

        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = pers;
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            pers.Name = "Hans Frisch";
            pers.Alter = 35;
            pers.Adresse = "Köln, Hauptstraße";
        }
    }

    public class Person : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;

        protected virtual void OnPropertyChanged(PropertyChangedEventArgs e)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, e);
        }

        private string _Name;
        public string Name
        {
            get { return _Name; }
            set
            {
                _Name = value;
                OnPropertyChanged(new PropertyChangedEventArgs("Name"));
            }
        }

        private int? _Alter;
        public int? Alter
        {
            get { return _Alter; }
            set
            {
                _Alter = value;
                OnPropertyChanged(new PropertyChangedEventArgs("Alter"));
            }
        }

        private string _Adresse;
        public string Adresse
        {
            get { return _Adresse; }
            set
            {
                _Adresse = value;
                OnPropertyChanged(new PropertyChangedEventArgs("Adresse"));
            }
        }
    }
}
