﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace IDataErrorInfoSample
{
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private Person pers = new Person { Name = "Peter", Alter = 33 };

        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = pers;
        }
    }

    // ---------------- die Klasse "Person" -------------------
    public class Person : INotifyPropertyChanged, IDataErrorInfo
    {
        public event PropertyChangedEventHandler PropertyChanged;

        public virtual void OnPropertyChanged(PropertyChangedEventArgs e)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, e);
        }

        private string _Name;
        public string Name
        {
            get { return _Name; }
            set
            {
                _Name = value;
                OnPropertyChanged(new PropertyChangedEventArgs("Name"));
            }
        }

        private int? _Alter;
        public int? Alter
        {
            get { return _Alter; }
            set
            {
                _Alter = value;
                OnPropertyChanged(new PropertyChangedEventArgs("Alter"));
            }
        }

        public string Error
        {
            get { return null; }
        }

        public string this[string propertyName]
        {
            get 
            {
                if (propertyName == "Alter")
                {
                    if(_Alter < 0)
                        return "Das Alter darf nicht negativ sein.";                   
                }
                return null;
            }
        }
    }
}
