﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace DataTriggerSample
{
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private ObservableCollection<Person> liste = new ObservableCollection<Person>();

        public MainWindow()
        {
            InitializeComponent();
            listBox1.ItemsSource = GetPersons();
            listBox1.SelectedIndex = 0;
            listBox1.Focus();
        }

        private ObservableCollection<Person> GetPersons()
        {       
            liste.Add(new Person { Name = "Schulze", Alter = 56, Adresse = "Bremen" });
            liste.Add(new Person { Name = "Schmidt", Alter = 21, Adresse = "Kiel" });
            liste.Add(new Person { Name = "Meier", Alter = 30, Adresse = "Bonn" });
            liste.Add(new Person { Name = "Schneider", Alter = 29, Adresse = "Ulm" });
            liste.Add(new Person { Name = "Müller", Alter = 26, Adresse = "Köln" });
            liste.Add(new Person { Name = "Fischer", Alter = 68, Adresse = "Bremen" });
            liste.Add(new Person { Name = "Klein", Alter = 73, Adresse = "Hamburg" });
            liste.Add(new Person { Name = "Miller", Alter = 64, Adresse = "Köln" });
            liste.Add(new Person { Name = "Abel", Alter = 77, Adresse = "Aachen" });
            liste.Add(new Person { Name = "Smith", Alter = 46, Adresse = "Berlin" });
            liste.Add(new Person { Name = "de Jong", Alter = 31, Adresse = "Essen" });
            liste.Add(new Person { Name = "Mayer", Alter = 31, Adresse = "Hannover" });
            return liste;
        }

        private void btnAdd_Click(object sender, RoutedEventArgs e)
        {
            liste.Add(new Person { Name = "Walter", Alter = 74, Adresse = "München" });
        }

        private void btnEditAge_Click(object sender, RoutedEventArgs e)
        {
            ((Person)listBox1.SelectedItem).Alter = 69;
        }

        private void btnDelete_Click(object sender, RoutedEventArgs e)
        {
            liste.Remove((Person)listBox1.SelectedItem);
        }
    }

    public class Person : INotifyPropertyChanged
    {
        // Ereignis
        public event PropertyChangedEventHandler PropertyChanged;

        protected virtual void OnPropertyChanged(PropertyChangedEventArgs e)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, e);
        }

        // Eigenschaften
        private string _Name;
        public string Name
        {
            get { return _Name; }
            set
            {
                _Name = value;
                OnPropertyChanged(new PropertyChangedEventArgs("Name"));
            }
        }

        private bool _Rente;
        public bool Rente
        {
            get
            {
                return _Rente;
            }

            private set
            {
                _Rente = value;
                OnPropertyChanged(new PropertyChangedEventArgs("Rente"));
            }
        }

        private int? _Alter;
        public int? Alter
        {
            get { return _Alter; }
            set
            {
                _Alter = value;
                if (Alter >= 65) Rente = true;
                else Rente = false;
                OnPropertyChanged(new PropertyChangedEventArgs("Alter"));
            }
        }

        private string _Adresse;
        public string Adresse
        {
            get { return _Adresse; }
            set
            {
                _Adresse = value;
                OnPropertyChanged(new PropertyChangedEventArgs("Adresse"));
            }
        }
    }
}
