﻿using System;
using System.Data;
using System.Data.SqlClient;

namespace CommandBuilderSample
{
    class Program
    {
        static void Main(string[] args)
        {
            SqlConnection con = new SqlConnection();
            con.ConnectionString = @"Data Source=.\sqlexpress;database=Northwind;Integrated Security=true";
            SqlCommand cmd = new SqlCommand();
            cmd.Connection = con;
            cmd.CommandText = "SELECT ProductID, ProductName, UnitsInStock, Discontinued FROM Products";
            DataSet ds = new DataSet();
            SqlDataAdapter da = new SqlDataAdapter(cmd);
            da.FillSchema(ds, SchemaType.Source);
            ds.Tables[0].Columns["ProductID"].AutoIncrementSeed = -1;
            ds.Tables[0].Columns["ProductID"].AutoIncrementStep = -1;
            da.Fill(ds);

            // Neue Datenzeile hinzufügen
            DataRow newRow = ds.Tables[0].NewRow();
            newRow["ProductName"] = "Camembert";
            newRow["UnitsInStock"] = 100;
            newRow["Discontinued"] = false;
            ds.Tables[0].Rows.Add(newRow);

            // Datenzeile ändern
            DataRow[] editRow = ds.Tables[0].Select("ProductName='Tofu'");
            if (editRow.Length == 1)
            {
                editRow[0].BeginEdit();
                editRow[0]["UnitsInStock"] = 1000;
                editRow[0].EndEdit();
            }
            else
                Console.WriteLine("Datenzeile 'Tofu' nicht gefunden.");

            // Datenbank aktualisieren
            // SqlCommandBuilder cmb = new SqlCommandBuilder(da);
            int count = da.Update(ds);
            Console.WriteLine("{0} Datenzeilen aktualisiert", count);
            Console.ReadLine();
        }

    }
}
