﻿using System;
using System.ComponentModel;


namespace GeometricObjects
{
  class Program
  {
    static void Main(string[] args)
    {
      Circle kreis = new Circle();
      // Ereignishandler registrieren
      kreis.InvalidMeasure += new InvalidMeasureEventHandler(kreis_InvalidMeasure);
      kreis.Moving += new MovingEventHandler(kreis_Moving);
      kreis.Moved += new MovedEventHandler(kreis_Moved);
      kreis.PropertyChanged += new PropertyChangedEventHandler(kreis_PropertyChanged);
      // Bezugspunkt verschieben
      kreis.Move(230, -136);
      // Eigenschaft ändern
      kreis.Radius = -99;
      // Ausgabe der Koordinatenwerte
      Console.WriteLine("\nKontrollwerte der Koordinaten:");
      Console.WriteLine("X = {0} / Y = {1}", kreis.XCoordinate, kreis.YCoordinate);
      Console.ReadLine();
    }

    // PropertyChanged
    static void kreis_PropertyChanged(object sender, PropertyChangedEventArgs e)
    {
      Console.WriteLine("\nDie Eigenschaft '{0}' hat sich geändert.", e.PropertyName);
    }

    // Moved
    static void kreis_Moved(object sender, EventArgs e)
    {
      Console.WriteLine("\nKreis erfolgreich verschoben.");
    }

    // Moving
    static void kreis_Moving(object sender, MovingEventArgs e)
    {
      Console.Write("Wollen Sie den Verschiebevorgang abbrechen (J/N)?");
      if (Console.ReadLine().ToUpper() == "J") e.Cancel = true;
    }

    // InvalidMeasure
    static void kreis_InvalidMeasure(object sender, InvalidMeasureEventArgs e)
    {
      Console.WriteLine("Zuweisungsfehler an '{0}'.", e.PropertyName);
      Console.Write("Ein Radius von {0} ist nicht möglich. Neueingabe: ", e.InvalidMeasure);
      if (sender is Circle)
        ((Circle)sender).Radius = Convert.ToInt32(Console.ReadLine());
    }
  }
}
