﻿using System;
using System.Collections;

namespace ArrayListAdapterSample
{
    class Program
    {
        static void Main(string[] args)
        {
            Person[] pers = new Person[3];
            pers[0] = new Person { Name = "Peter", City = "Celle" };
            pers[1] = new Person { Name = "Alfred", City = "München" };
            pers[2] = new Person { Name = "Hugo", City = "Aachen" };
            ArrayList liste = ArrayList.Adapter(pers);
            // Sortierung nach den Namen
            liste.Sort(new NameComparer());
            Console.WriteLine("Sortiert nach den Namen:");

            for (int index = 0; index < 3; index++)
                if (liste[index] != null)
                    Console.WriteLine(((Person)liste[index]).Name);
            // Sortierung nach dem Wohnort
            Console.WriteLine("\nSortiert nach dem Wohnort:");
            liste.Sort(new CityComparer());

            for (int index = 0; index < 3; index++)
                if (liste[index] != null)
                    Console.WriteLine(((Person)liste[index]).City);
            Console.ReadLine();
        }
    }

    // Vergleichsklasse – Kriterium City
    class CityComparer : IComparer
    {
        public int Compare(object x, object y)
        {
            // prüfen auf null-Übergabe
            if (x == null && y == null) return 0;
            if (x == null) return -1;
            if (y == null) return 1;
            // Typüberprüfung
            if (x.GetType() != y.GetType())
                throw new ArgumentException("Ungültiger Vergleich");
            // Vergleich
            return ((Person)x).City.CompareTo(((Person)y).City);
        }
    }


    // Vergleichsklasse – Kriterium Name
    class NameComparer : IComparer
    {
        public int Compare(object x, object y)
        {
            // prüfen auf null-Übergabe
            if (x == null && y == null) return 0;
            if (x == null) return -1;
            if (y == null) return 1;
            // Typüberprüfung
            if (x.GetType() != y.GetType())
                throw new ArgumentException("Ungültiger Vergleich");
            // Vergleich
            return ((Person)x).Name.CompareTo(((Person)y).Name);
        }
    }

    class Person
    {
        public string Name { get; set; }
        public string City { get; set; }
    }
}
